commit 737cea7b1e10c9465436f87c19cc065d17a6c47f
Author: freddy77 <freddy77>
Date:   Mon Jan 11 18:14:10 2010 +0000

    do not allow bot port and instance to be specified

diff --git a/ChangeLog b/ChangeLog
index 05573f6..5713f2b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon Jan 11 19:14:03 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/config.c src/tds/login.c src/tds/mem.c:
+	* src/tds/util.c:
+	- do not allow bot port and instance to be specified
+
 Mon Jan 11 13:03:29 EST 2010	JK Lowden <jklowden@freetds.org>
 	* include/replacements.h more care with strcasecmp macro
 
@@ -2113,4 +2118,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2937 2010/01/11 18:04:04 jklowden Exp $
+$Id: ChangeLog,v 1.2938 2010/01/11 18:14:10 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index e4c3d16..c278da4 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.324 2009/12/28 13:30:31 freddy77 Exp $ */
+/* $Id: tds.h,v 1.325 2010/01/11 18:14:10 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -287,7 +287,8 @@ typedef enum {	TDSEOK    = TDS_SUCCEED,
 		TDSEICONVAVAIL = 2401, 
 		TDSEICONVO     = 2402, 
 		TDSEICONVI     = 2403, 
-		TDSEICONV2BIG  = 2404, 
+		TDSEICONV2BIG  = 2404,
+		TDSEPORTINSTANCE	= 2500,
 		TDSESYNC = 20001, 
 		TDSEFCON = 20002, 
 		TDSETIME = 20003, 
diff --git a/src/tds/config.c b/src/tds/config.c
index 3111878..5857c88 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.153 2010/01/10 14:43:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.154 2010/01/11 18:14:10 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -630,10 +630,8 @@ tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login)
 	if (login->block_size) {
 		connection->block_size = login->block_size;
 	}
-	if (login->port) {
+	if (login->port)
 		connection->port = login->port;
-		tds_dstr_copy(&connection->instance_name, "");
-	}
 	if (login->connect_timeout)
 		connection->connect_timeout = login->connect_timeout;
 
@@ -1040,11 +1038,7 @@ tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 			 * Not set in the [global] section of the
 			 * configure file, take a guess.
 			 */
-#ifdef TDS50
-			ip_port = 4000;
-#else
-			ip_port = 1433;
-#endif
+			ip_port = TDS_DEF_PORT;
 		} else {
 			/*
 			 * Preserve setting from the [global] section
@@ -1091,14 +1085,12 @@ parse_server_name_for_port(TDSCONNECTION * connection, TDSLOGIN * login)
 	if (pSep && pSep != server) {	/* yes, i found it! */
 		/* modify connection-> && login->server_name & ->port */
 		login->port = connection->port = atoi(pSep + 1);
-		tds_dstr_copy(&connection->instance_name, "");
 	} else {
 		/* handle instance name */
 		pSep = strrchr(server, '\\');
 		if (!pSep || pSep == server)
 			return 0;
 
-		login->port = connection->port = 0;
 		tds_dstr_copy(&connection->instance_name, pSep + 1);
 	}
 
diff --git a/src/tds/login.c b/src/tds/login.c
index c16dcb7..6c33546 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.192 2010/01/10 14:43:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.193 2010/01/11 18:14:10 freddy77 Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -427,6 +427,11 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		return TDSECONN;
 	}
 
+	if (connection->port && !tds_dstr_isempty(&connection->instance_name)) {
+		tdserror(tds->tds_ctx, tds, TDSEPORTINSTANCE, 0);
+		return TDSECONN;
+	}
+
 	if (!IS_TDS50(tds) && !tds_dstr_isempty(&connection->instance_name))
 		connection->port = tds7_get_instance_port(tds_dstr_cstr(&connection->ip_addr), tds_dstr_cstr(&connection->instance_name));
 
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 588c8b6..c17209b 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.195 2010/01/08 22:41:35 jklowden Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.196 2010/01/11 18:14:10 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -813,7 +813,6 @@ tds_alloc_connection(TDSLOCALE * locale)
 	if (!tds_dstr_copy(&connection->server_name, TDS_DEF_SERVER))
 		goto Cleanup;
 	connection->tds_version = TDS_DEFAULT_VERSION;
-	connection->port = TDS_DEF_PORT;
 	connection->block_size = 0;
 	/* TODO use system default ?? */
 	if (!tds_dstr_copy(&connection->client_charset, "ISO-8859-1"))
diff --git a/src/tds/util.c b/src/tds/util.c
index 15a6daa..45bdb7e 100644
--- a/src/tds/util.c
+++ b/src/tds/util.c
@@ -65,7 +65,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: util.c,v 1.88 2010/01/10 14:43:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: util.c,v 1.89 2010/01/11 18:14:10 freddy77 Exp $");
 
 void
 tds_set_parent(TDSSOCKET * tds, void *the_parent)
@@ -255,6 +255,7 @@ static const TDS_ERROR_MESSAGE tds_error_messages[] =
 	, { TDSEICONVI,      EXCONVERSION,	"Some character(s) could not be converted into client's character set.  "
 						"Unconverted bytes were changed to question marks ('?')" }
 	, { TDSEICONV2BIG,   EXCONVERSION,	"Some character(s) could not be converted into client's character set" }
+	, { TDSEPORTINSTANCE,      EXCOMM,      "Both port and instance specified" }
 	, { TDSERPND,           EXPROGRAM,	"Attempt to initiate a new Adaptive Server operation with results pending" }
 	, { TDSEBTOK,              EXCOMM,	"Bad token from the server: Datastream processing out of sync" }
 	, { TDSECAP,               EXCOMM,	"DB-Library capabilities not accepted by the Server" }

